package de.qsqs.testgui;


import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import junit.extensions.abbot.*;
import abbot.tester.*;

public class MyTest extends ComponentTestFixture {

	private static ComponentTester tester;
	private String clickType;
	MyMainPanel oPanel;
	MyMenuBar oMenu;
	
	

	
	protected void setUp() {
		oPanel = new MyMainPanel();
		oMenu = new MyMenuBar();
		tester = new ComponentTester();
		new MyMainWindow();
	}
	
	protected void tearDown() {
		// Default JUnit test runner keeps references to Tests for its
		// lifetime, so TestCase fields won't be GC'd for the lifetime of the
		// runner. 
		tester = null;
	}
	
	
	public static void main(String[] args) {
		
		TestHelper.runTests(args, MyTest.class);
	}
	
	/**
	 * Methode testet die Gui Elemente, wie Buttons, Label, Combobox, Textfield
	 *
	 */
	public void testButtons() {
		
		ActionListener al = new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				clickType = ev.getActionCommand();                            
				}
			};
	           
		/*Fügt die TestObjekte zum ActionListener hinzu*/
		oPanel.getButtonCount().addActionListener(al);
	    oPanel.getJButtonReset().addActionListener(al);
	    oPanel.getComboBox().addActionListener(al);
	    	    
	    
	    /*Count Button*/
	    tester.actionDelay(1000);
		tester.actionClick(oPanel.getButtonCount());
		assertEquals("Click Count failed", "Count", clickType);
		
		tester.getLabel(oPanel.getJLabel());
		
		assertEquals("Label not equals!", "Counter : 1", oPanel.getJLabel().getText());
		
		/*Testet den Reset Button*/
		clickType = null;
		tester.actionClick(oPanel.getJButtonReset());
		assertEquals("Click reset failed", "Reset", clickType);
		tester.actionDelay(1000);
			
	}
	
	/**
	 * Testet die Combobox
	 *
	 */
	public void testComboBox(){
		
		tester.actionClick(oPanel.getComboBox());
		oPanel.getComboBox().setSelectedIndex(1);
		tester.actionDelay(1000);
		assertEquals("Error while testing Combobox", "Student", oPanel.getComboBox().getSelectedItem().toString());
		tester.actionDelay(1000);
	}
	
	/**
	 * Testet die Text Area
	 * */
	public void testTextArea(){
	
		tester.actionKeyString(oPanel.oTextArea, "Testmeldung");
		assertEquals("Testmeldung", oPanel.getTextArea().getText());
	}
}
